/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include <qt.h>
#include <qvalidator.h>
#include <qmessagebox.h>

#include <qdatetime.h>

#include <qlabel.h>
#include <qpixmap.h>

#include <qlineedit.h>
#include <qapplication.h>
#include<iostream>
#include<coordinates.h>

using namespace std;

#define MsgBoxTitle	"CalculDeclination"
#define MsgCtrlLat		"Latitude beetween -90  & +90 degree\n" "please, once again latitude"
#define MsgCtrlLong	"Longitude beetween -180  & +180 degree\n" "please, once again longitude"
#define MsgCtrlAlt	"Altitude < 1000000 meters"

#define MsgLifeSpan "\n\n WARNING - TIME EXTENDS BEYOND MODEL 5-YEAR LIFE SPAN \n CONTACT NIMA FOR PRODUCT UPDATES:\n         NATIONAL IMAGING AND MAPPING AGENCY\n         ATTN: CODE P33\n         12310 SUNRISE VALLEY DRIVE\n         RESTON, VA 20191-3449\n         PHONE: (703) 264-3133\n         EMAIL: martinod@nima.mil"


Coord coord;
int verif = 0;

void DeclinaisonForm::CalculDeclinaison()
{	extern float  calcul_decliner(float, float, float, float );
	float input=0;
	float latde=0;
	float longde=0;
	float altde=0;
	
	// LATITUDE input
	input = LatitudeLineEdit->text().toDouble();
	if (coord.ControlLatitude(input))
	{	LatitudeLineEdit->undo();
		LongitudeLineEdit->deselect();
		LongitudeLineEdit->clearFocus();
		QMessageBox::information( this, MsgBoxTitle, MsgCtrlLat );
		LatitudeLineEdit->clear();
		LatitudeLineEdit->setFocus();
	}
	latde = coord.AssignLatitude(input);	
	
	// LONGITUDE input
	input = LongitudeLineEdit->text().toDouble();
	if (coord.ControlLongitude(input))
	{	LongitudeLineEdit->undo();
		YearComboBox->clearFocus();
		AltitudeLineEdit->deselect();
		QMessageBox::information( this, MsgBoxTitle, MsgCtrlLong );
		LongitudeLineEdit->clear();
		LongitudeLineEdit->setFocus();	
	}
	longde = coord.AssignLongitude(input);
	
	//YEAR input ( optional )
	switch ( YearComboBox->currentItem() )
	{	case 0: input  = 2000;break;
		case 1: input  = 2001;break;
		case 2: input  = 2002;break;
		case 3: input  = 2003;break;
		case 4: input  = 2004;break;
		case 5: input  = 2005;break;
		default: input  = 2004;break;
	}
	float year = input ;	
	
		// Altitude input
	input = AltitudeLineEdit->text().toDouble();
	if (coord.ControlAltitude(input))
	{	AltitudeLineEdit->undo();
		QMessageBox::information( this, MsgBoxTitle, MsgCtrlAlt );
		AltitudeLineEdit->clear();
		AltitudeLineEdit->setFocus();
	}
	altde = coord.AssignAltitude(input);
	
	// Variation Calcul
	float result=calcul_decliner(latde, longde, year, altde);
	// Variation
	DeclinaisonLabel->setText( QString::number( result, 'f', 2 ) );
}


void DeclinaisonForm::keyPressEvent( QKeyEvent * e ) 
{	if (verif == 1) e->ignore();
}


void DeclinaisonForm::mousePressEvent( QMouseEvent *e )
{	int ptx 				= e->x();
	int pty 				= e->y();
	float largcarte	= 581;							// wide chart (pixel)
	float hautcarte	= 320;							// height chart (pixel)
	float latde 			= 0;								// latitude ( decimal )
	float longde 		= 0;								// longitude ( decimal )
	float altde			= 	0;								// altitude ( decimal )
	
/* question	
	Pour Quelle raison ne puis-je pas mes servir des propiètès Width du Qlabel MondePixMapLabel ?
	int lgcarte			= MondePixMapLabel.Width();
	int htcarte			= MondePixMapLabel->Height();
	int lgcarte			= MondePixMapLabel.minimumSize().width();
*/
	
		float input = AltitudeLineEdit->text().toDouble();
		if (coord.ControlAltitude(input))
		{	AltitudeLineEdit->undo();
			QMessageBox::information( this, MsgBoxTitle, MsgCtrlAlt );
			AltitudeLineEdit->clear();
			AltitudeLineEdit->setFocus();
		}
		altde = coord.AssignAltitude(input);

	// Transformation of the point (pointed by the mouse) into geographical co-ordinates
	if (( pty >= 0 && pty < hautcarte) && ( ptx >= 0 && ptx < largcarte ))
	{	latde = coord.CalculLatitude(pty, hautcarte);
		longde = coord.CalculLongitude(ptx, largcarte);
				
		if (coord.ControlLatitude(latde))
		{	QMessageBox::information( this, MsgBoxTitle, MsgCtrlLat );
			LatitudeLineEdit->selectAll ();
			LatitudeLineEdit->setFocus();
		}
		
		if (coord.ControlLongitude(longde))
		{	QMessageBox::information( this, MsgBoxTitle, MsgCtrlLong );
			LongitudeLineEdit->selectAll ();
			LongitudeLineEdit->setFocus();
		}
		
		LatitudeLineEdit->setText(QString::number( latde, 'f', 2 ));
		LongitudeLineEdit->setText(QString::number( longde, 'f', 2 ));
		CalculDeclinaison();
		DeclinaisonLabel->setPaletteForegroundColor("#aa0000");
		LatitudeLineEdit->setFocus();
		LatitudeLineEdit->selectAll();
	}	
}

void DeclinaisonForm::ValidPeriod()
{	QDate date = QDate::currentDate();
	if(date.year()>2005) QMessageBox::information( this, MsgBoxTitle, MsgLifeSpan );
}

void DeclinaisonForm::init()
{
	LatitudeLineEdit->setValidator( new QDoubleValidator( LatitudeLineEdit ) );
	LatitudeLineEdit->setText( "47.92" );
	
	LongitudeLineEdit->setValidator( new QDoubleValidator( LongitudeLineEdit ) );
	LongitudeLineEdit->setText( "-5.53" );
	
	AltitudeLineEdit->setValidator( new QDoubleValidator( AltitudeLineEdit ) );
	AltitudeLineEdit->setText( "0" );
	ValidPeriod();
	CalculDeclinaison();
	DeclinaisonLabel->setPaletteForegroundColor("#aa0000");
	LatitudeLineEdit->setFocus();
	LatitudeLineEdit->selectAll();
	
}

